



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浏览器退出之后php还会继续执行么？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浏览器退出之后php还会继续执行么？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 23:41:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>浏览器退出之后php还会继续执行么？</h1>
<p>前提：这里说的是典型的lnmp结构，nginx+php-fpm的模式</p>
<p>如果我有个php程序执行地非常慢，甚至于在代码中sleep()，然后浏览器连接上服务的时候，会启动一个php-fpm进程，但是这个时候，如果浏览器关闭了，那么请问，这个时候服务端的这个php-fpm进程是否还会继续运行呢？</p>
<p>今天就是要解决这个问题。</p>
<h1>最简单的实验</h1>
<p>最简单的方法就是做实验，我们写一个程序：在sleep之前和之后都用file_put_contents来写入日志：</p>
<pre class="prettyprint linenums"><code>&lt;?php<br />
file_put_contents('/tmp/test.log', '11111' . PHP_EOL, FILE_APPEND | LOCK_EX);<br />
sleep(3);<br />
file_put_contents('/tmp/test.log', '2222' . PHP_EOL, FILE_APPEND | LOCK_EX);<br />
</code></pre>
<p>实际操作的结果是，我们在服务器sleep的过程中，关闭客户端浏览器，2222是会被写入日志中。</p>
<p>那么就意味着浏览器关闭以后，服务端的php还是会继续运行的?</p>
<h1>ignore_user_abort</h1>
<p>老王和diogin提醒，这个可能是和php的ignore_user_abort函数相关。</p>
<p>于是我就把代码稍微改成这样的：</p>
<pre class="prettyprint linenums"><code>&lt;?php<br />
ignore_user_abort(false);<br />
file_put_contents('/tmp/test.log', '11111' . PHP_EOL, FILE_APPEND | LOCK_EX);<br />
sleep(3);<br />
file_put_contents('/tmp/test.log', '2222' . PHP_EOL, FILE_APPEND | LOCK_EX);<br />
</code></pre>
<p>发现并没有任何软用，不管设置ignore_user_abort为何值，都是会继续执行的。</p>
<p>但是这里有一个疑问: user_abort是什么？</p>
<p><img referrerpolicy="no-referrer"src="http://i3.piimg.com/e5aa1ad98005660d.png"></p>
<p>文档对cli模式的abort说的很清楚，当php脚本执行的时候，用户终止了这个脚本的时候，就会触发abort了。然后脚本根据ignore_user_abort来判断是否要继续执行。</p>
<p>但是官方文档对cgi模式的abort并没有描述清楚。感觉即使客户端断开连接了，在cgi模式的php是不会收到abort的。<br /><br />
难道ignore_user_abort在cgi模式下是没有任何作用的？</p>
<h1>是不是心跳问题呢？</h1>
<p>首先想到的是不是心跳问题呢？我们断开浏览器客户端，等于在客户端没有close而断开了连接，服务端是需要等待tcp的keepalive到达时长之后才会检测出来的。</p>
<p>好，需要先排除浏览器设置的keepalive问题。</p>
<p>抛弃浏览器，简单写一个client程序：程序连接上http服务之后，发送一个header头，sleep1秒就主动close连接，而这个程序并没有带http的keepalive头。</p>
<p>程序如下：</p>
<pre class="prettyprint linenums"><code>package main

import &quot;net&quot;<br />
import &quot;fmt&quot;<br />
import &quot;time&quot;

func main() {<br />
	conn, _ := net.Dial(&quot;tcp&quot;, &quot;192.168.33.10:10011&quot;)<br />
	fmt.Fprintf(conn, &quot;GET /index.php HTTP/1.0\r\n\r\n&quot;)<br />
	time.Sleep(1 * time.Second)<br />
	conn.Close()<br />
	return<br />
}<br />
</code></pre>
<p>服务端程序：</p>
<pre class="prettyprint linenums"><code>&lt;?php<br />
ignore_user_abort(false);<br />
file_put_contents('/tmp/test.log', '11111' . PHP_EOL, FILE_APPEND | LOCK_EX);<br />
sleep(3);<br />
file_put_contents('/tmp/test.log', '2222' . PHP_EOL, FILE_APPEND | LOCK_EX);<br />
</code></pre>
<p>发现仍然还是一样，php还是不管是否设置ignore_user_abort，会继续执行完成整个脚本。看来ignore_user_abort还是没有生效。</p>
<h1>如何触发ignore_user_abort</h1>
<p>那该怎么触发ignore_user_abort呢？服务端这边怎么知晓这个socket不能使用了呢？老王和diogin说是不是需要服务端主动和socket进行交互，才会判断出这个socket是否可以使用？</p>
<p>另外，我们还发现，php提供了connection_status和connection_aborted两个方法，这两个方法都能检测出当前的连接状态。于是我们的打日志的那行代码就可以改成：</p>
<pre class="prettyprint linenums"><code>file_put_contents('/tmp/test.log', '1 connection status: ' . connection_status() . &quot;abort:&quot; . connection_aborted() . PHP_EOL, FILE_APPEND | LOCK_EX);<br />
</code></pre>
<p>根据手册<a href="http://php.net/manual/zh/features.connection-handling.php" rel="external nofollow noreferrer">连接处理</a>显示我们可以打印出当前连接的状态了。</p>
<p>下面还缺少一个和socket交互的程序，我们使用echo，后面也顺带记得带上flush，排除了flush的影响。</p>
<p>程序就改成：</p>
<pre class="prettyprint linenums"><code>&lt;?php<br />
ignore_user_abort(true);<br />
file_put_contents('/tmp/test.log', '1 connection status: ' . connection_status() . &quot;abort:&quot; . connection_aborted() . PHP_EOL, FILE_APPEND | LOCK_EX);

sleep(3);

for($i = 0; $i &lt; 10; $i++) {<br />
        echo &quot;22222&quot;;<br />
        flush();<br />
        sleep(1);<br />
        file_put_contents('/tmp/test.log', '2 connection status: ' . connection_status() . &quot;abort:&quot; . connection_aborted(). PHP_EOL, FILE_APPEND | LOCK_EX);<br />
}<br />
</code></pre>
<p>很好，执行我们前面写的client。观察日志：</p>
<pre class="prettyprint linenums"><code>1 connection status: 0abort:0<br />
2 connection status: 0abort:0<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
2 connection status: 1abort:1<br />
</code></pre>
<p>终于制造出了abort。日志也显示后面几次的abort状态都是1。</p>
<p>但是这里有个奇怪的地方，为什么第一个2 connection status的状态还是0呢（NORMAL）。</p>
<h1>RST</h1>
<p>我们使用wireshark抓包看整个客户端和服务端交互的过程</p>
<p><img referrerpolicy="no-referrer"src="http://i3.piimg.com/eca4e0ba0e96e77a.png"></p>
<p>这整个过程只有发送14个包，我们看下服务端第一次发送22222的时候，客户端返回的是RST。后面就没有进行后续的包请求了。</p>
<p>于是理解了，客户端和服务端大概的交互流程是：</p>
<p>当服务端在循环中第一次发送2222的时候，客户端由于已经断开连接了，返回的是一个RST，但是这个发送过程算是请求成功了。直到第二次服务端再次想往这个socket中进行write操作的时候，这个socket就不进行网络传输了，直接返回说connection的状态已经为abort。所以就出现了上面的情况，第一次222是status为0，第二次的时候才出现abort。</p>
<h1>strace进行验证</h1>
<p>我们也可以使用strace php -S XXX来进行验证</p>
<p>整个过程strace的日志如下：</p>
<pre class="prettyprint linenums"><code>。。。<br />
close(5)                                = 0<br />
lstat(&quot;/tmp/test.log&quot;, {st_mode=S_IFREG|0644, st_size=49873651, ...}) = 0<br />
open(&quot;/tmp/test.log&quot;, O_WRONLY|O_CREAT|O_APPEND, 0666) = 5<br />
fstat(5, {st_mode=S_IFREG|0644, st_size=49873651, ...}) = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
flock(5, LOCK_EX)                       = 0<br />
write(5, &quot;1 connection status: 0abort:0\n&quot;, 30) = 30<br />
close(5)                                = 0<br />
sendto(4, &quot;HTTP/1.0 200 OK\r\nConnection: clo&quot;..., 89, 0, NULL, 0) = 89<br />
sendto(4, &quot;111111111&quot;, 9, 0, NULL, 0)   = 9<br />
rt_sigprocmask(SIG_BLOCK, [CHLD], [], 8) = 0<br />
rt_sigaction(SIGCHLD, NULL, {SIG_DFL, [], 0}, 8) = 0<br />
rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0<br />
nanosleep({3, 0}, 0x7fff60a40290)       = 0<br />
sendto(4, &quot;22222&quot;, 5, 0, NULL, 0)       = 5<br />
open(&quot;/tmp/test.log&quot;, O_WRONLY|O_CREAT|O_APPEND, 0666) = 5<br />
fstat(5, {st_mode=S_IFREG|0644, st_size=49873681, ...}) = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
flock(5, LOCK_EX)                       = 0<br />
write(5, &quot;2 connection status: 0abort:0\n&quot;, 30) = 30<br />
close(5)                                = 0<br />
rt_sigprocmask(SIG_BLOCK, [CHLD], [], 8) = 0<br />
rt_sigaction(SIGCHLD, NULL, {SIG_DFL, [], 0}, 8) = 0<br />
rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0<br />
nanosleep({1, 0}, 0x7fff60a40290)       = 0<br />
sendto(4, &quot;22222&quot;, 5, 0, NULL, 0)       = -1 EPIPE (Broken pipe)<br />
--- SIGPIPE {si_signo=SIGPIPE, si_code=SI_USER, si_pid=2819, si_uid=0} ---<br />
open(&quot;/tmp/test.log&quot;, O_WRONLY|O_CREAT|O_APPEND, 0666) = 5<br />
fstat(5, {st_mode=S_IFREG|0644, st_size=49873711, ...}) = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
flock(5, LOCK_EX)                       = 0<br />
write(5, &quot;2 connection status: 1abort:1\n&quot;, 30) = 30<br />
close(5)                                = 0<br />
rt_sigprocmask(SIG_BLOCK, [CHLD], [], 8) = 0<br />
rt_sigaction(SIGCHLD, NULL, {SIG_DFL, [], 0}, 8) = 0<br />
rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0<br />
nanosleep({1, 0}, 0x7fff60a40290)       = 0<br />
open(&quot;/tmp/test.log&quot;, O_WRONLY|O_CREAT|O_APPEND, 0666) = 5<br />
fstat(5, {st_mode=S_IFREG|0644, st_size=49873741, ...}) = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
flock(5, LOCK_EX)                       = 0<br />
write(5, &quot;2 connection status: 1abort:1\n&quot;, 30) = 30<br />
close(5)<br />
。。。<br />
</code></pre>
<p>我们照中看status从0到1转变的地方。</p>
<pre class="prettyprint linenums"><code>...<br />
sendto(4, &quot;22222&quot;, 5, 0, NULL, 0)       = 5<br />
...<br />
write(5, &quot;2 connection status: 0abort:0\n&quot;, 30) = 30<br />
close(5)                                = 0<br />
rt_sigprocmask(SIG_BLOCK, [CHLD], [], 8) = 0<br />
rt_sigaction(SIGCHLD, NULL, {SIG_DFL, [], 0}, 8) = 0<br />
rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0<br />
nanosleep({1, 0}, 0x7fff60a40290)       = 0<br />
sendto(4, &quot;22222&quot;, 5, 0, NULL, 0)       = -1 EPIPE (Broken pipe)<br />
--- SIGPIPE {si_signo=SIGPIPE, si_code=SI_USER, si_pid=2819, si_uid=0} ---<br />
open(&quot;/tmp/test.log&quot;, O_WRONLY|O_CREAT|O_APPEND, 0666) = 5<br />
fstat(5, {st_mode=S_IFREG|0644, st_size=49873711, ...}) = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
lseek(5, 0, SEEK_CUR)                   = 0<br />
flock(5, LOCK_EX)                       = 0<br />
write(5, &quot;2 connection status: 1abort:1\n&quot;, 30) = 30<br />
close(5)                                = 0<br />
</code></pre>
<p>第二次往socket中发送2222的时候显示了Broken pipe。这就是程序告诉我们，这个socket已经不能使用了，顺便php中的connection_status就会被设置为1了。后续的写操作也都不会再执行了。</p>
<h1>总结</h1>
<p>正常情况下，如果客户端client异常推出了，服务端的程序还是会继续执行，直到与IO进行了两次交互操作。服务端发现客户端已经断开连接，这个时候会触发一个user_abort，如果这个没有设置ignore_user_abort，那么这个php-fpm的程序才会被中断。</p>
<p>至此，问题结了。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pe378x.html">Fiddler--一、HTTP协议简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1yzrzq.html">ListView显示不同行以及数据重用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyomlg8.html">Chrome扩展开发之二&mdash;&mdash;Chrome扩展中脚本的运行机制和通信方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m04g09.html">sizeof&lpar;&rpar;用法汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq40x5n8.html">ASP&period;NET MVC数组模型绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0jl5eq.html">linux设备驱动归纳总结（四）：1&period;进程管理的相关概念【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1wl1q.html">mysql 关联删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnwwwoq.html">16进制串hex与ASCII字符串相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mdegkq.html">storm入门教程 第一章 前言&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvn23yq.html">simplemodal &mdash; jquery弹出窗体插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdy0ek8.html">cocoaPods教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0k674q.html">Java入门基础总结&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjd32k8.html">c&plus;&plus;野指针 之 实战篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrxm38.html">&lbrack;转&rsqb;Bypassing iOS security</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljoj519.html">Html 嵌入 swf</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkzo4d8.html">Kinect v2&lpar;Microsoft Kinect for Windows v2 &rpar;配置移动电源解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpg0x8.html">Github 上怎样把新 commits 使用在自己的 fork 上</a>
		</li>
						<li><a href="https://www.batexi.com/a/95057kv8.html">如何彻底禁止win10易升更新（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2dk2x9.html">James 3&period;1服务器的安装与搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ywglq.html">js day01</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49gzvl78.html">团队项目&mdash;&mdash;站立会议DAY12</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96lr0y9.html">Ngnice-国内ng学习网站</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvjyexq.html">C&num; WPF  让你的窗口始终钉在桌面上</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdgyr7q.html">关于Web开发里并发、同步、异步以及事件驱动编程的相关技术</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlwr718.html">微信自定义分享到朋友圈API</a>
			</li>
						<li><a href="https://www.batexi.com/a/3904gk48.html">Unity3d使用经验总结 数据驱动篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1y154q.html">如何在 IIS 上搭建 mercurial server</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o3z6p8.html">Redis集群~StackExchange&period;Redis&lpar;10月6号版1&period;1&period;608&period;0&rpar;连接Twemproxy支持Auth指令了</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1yed6q.html">20&lowbar;学生选课数据库SQL语句练习题1</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlwzex8.html">atitit。ocr框架类库大全 attilax总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
